=== debian/control ===
Source: ros-melodic-uuv-sensor-ros-plugins
Section: misc
Priority: extra
Maintainer: Musa Morena Marcusso Manhaes <musa.marcusso@de.bosch.com>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-gazebo-dev, ros-melodic-gazebo-plugins, ros-melodic-geometry-msgs, ros-melodic-image-transport, ros-melodic-laser-geometry, ros-melodic-message-filters, ros-melodic-roscpp, ros-melodic-rostest, ros-melodic-rosunit, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-tf, ros-melodic-tf2, ros-melodic-tf2-ros, ros-melodic-uuv-gazebo-plugins, ros-melodic-uuv-sensor-ros-plugins-msgs, ros-melodic-xacro
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-uuv-sensor-ros-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-gazebo-dev, ros-melodic-gazebo-plugins, ros-melodic-geometry-msgs, ros-melodic-image-transport, ros-melodic-laser-geometry, ros-melodic-message-filters, ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-tf, ros-melodic-tf2, ros-melodic-tf2-ros, ros-melodic-uuv-gazebo-plugins, ros-melodic-uuv-sensor-ros-plugins-msgs
Description: The uuv_sensor_ros_plugins package
